#ifndef _TABLERO_
#define _TABLERO_

using namespace std;
#include <iostream>
/**
 * @brief Clase Tablero
 * 
 *@author Lourdes
*/
class tablero{
public: 
  /**Constructor de Tablero
  *@param string level con el nombre del archivo donde está el nivel representado
  */	
  tablero(string level);
  
  /**Funcion para mover al granjero por el tablero
  *@param int x, int y  
  *x=0 y=1 mover abajo, 	x=0 y=-1 mover arriba
  *x=1 y=0 mover derecha, x=-1 y=0 mover izquierda
  *@return bool, verdadero si mueve al cerdo y falso en caso contrario
  */ 
  bool mover(int x,int y);

  /**Funcion que comprueba si el movimiento del granjero es valido
  *El movimiento es valido si no sobrepasa el terreno de juego, y si no hay ningun obstaculo que lo impida
  *@param int x, int y
  *@return bool, verdadero si movimiento valido y falso en caso contrario
  */     
  bool movimiento_valido(int x, int y);

  /**Funcion que comprueba si el nivel ha sido superado
  *@return bool, verdadero si nivel superdo y falso en caso contrario
  */
  bool comprobar();

  /**Funcion que devuelve el tablero a su situación inicial*/
  void restaurar();

  //void imprimir();

  /**Funcion para localizar al granjero dentro del terreno de juego
  *@param int &i, int &j. Almacena la posición (i,j) donde se encuentra el granjero dentro de la matriz

  */	      
  void buscar_granjero(int &i, int &j);

  /** @ {
  *Representación del tablero y las bellotas. Matriz de 12x12 */
  int tablero_[12][12]; 
  int bellotas_[12][12];
  float pasos_;
  float pasos_andados;
  float puntuacion_;
  int nivel;
  /** @ } */
   
private:
  
  /**Enumerado con las casillas del tablero */
  /*****************************************//**
  * -1	Casilla invalida
  * 0		Casilla libre
  * 1		Granjero
  *	2		Cerdo
  * 3		Bellota
  * 4		Valla trasera (valla_tras)
  * 5 	Valla delantera (valla_del)
  * 6		Valla izquierda (valla_izq)
  * 7		Valla derecha (valla_der)
  * 8 	Valla esquina trasera izquierda (tras_izq)
  * 9 	Valla esquina trasera derecha	(tras_der)
  * 10	Valla	esquina delantera izquierda (del_izq)
  * 11  Valla esquina delantera derecha (del_der)
  *********************************************/
  enum{invalida=-1,libre,granjero,cerdo,bellota,valla_tras,valla_del,valla_izq,valla_der,tras_izq,tras_der,del_izq,del_der};

  /**Atributo para almacenar el nombre del fichero donde está el nivel. */				
  string nombre_; 
};

#endif
