#include <Gosu/Gosu.hpp>
#include <iostream>
#include "ventana.h"

Ventana::Ventana(Sonido & sonido): Gosu::Window(800, 600, false),sonido_(sonido){//Constructor de Ventana, llama al constructor de Window con el ancho y el alto    
  fondo = new Gosu::Image(graphics(), /*pantalla*/ L"../Imagenes/Fondo.png"); /*ruta*/ 
  
  ifstream fichero;
  fichero.open ("../Niveles/bloqueado", ios::in); //se lee el fichero del nivel correspondiente
  int aux;
  fichero >> aux; 
  fichero >> puntuacion_total_;
  fichero.close();
  
  guardado_ = aux;
  
  principal = new Principal(graphics(),sonido);
  menu = new Menu(graphics(),sonido);
  nivel = new Nivel(graphics(),sonido);
  creditos = new Creditos(graphics());
  c= new Completado(graphics());
  nube = new Nube(graphics());
  
  //sonido.sonidofondo()-> play(true);
  principal_ =1;  //ponemos el menu principal a 1 porque es la primera ventana que se muestra
  nivel_ ="0"; //ponemos el menu a o porque inicialemente no queremos tener ningun nivel visible
  menu_=0;      //ponemos el menu a 1 para que al mostrar la ventana lo primero que salga sea el menu 
  mira_ = 0;
  animacion_ = 0;
  creditos_ = 0;
  completo_=0;
  puntuacion_=0;
  sonido.silencio()=false;
}

Ventana::~Ventana(){
  //eliminamos la memoria reservada
  delete fondo;  
  ofstream fichero;
  fichero.open ("../Niveles/bloqueado", ofstream::out); //se lee del fichero el nivel por el que vamos.
  fichero << guardado_;
  fichero << " " << puntuacion_total_;
  fichero.close();
}

void Ventana::update(){
  draw();
}

//FUNCIONES DRAW
void Ventana::draw(){

  fondo -> draw(0, 0, 0);

  if(principal_ == 1){
    principal->draw();
  }//fin principal == 1
  
  else if (menu_ == 1){ //Si estamos en el menu de niveles
    menu->draw(guardado_);
  } //fin menu=1

  else if(nivel_ != "0"){ //Si estamos en un nivel	
    nivel->draw(t, mira_, animacion_, puntuacion_total_);
    nube->draw();
  }//fin nivel != 0	

  if(creditos_ == 1)
    creditos->draw();

  if(completo_ == 1)
    c->draw(puntuacion_, puntuacion_total_);
}

//FUNCIONES 
void Ventana::buttonDown(Gosu::Button B){ //Al pulsar cualquier tecla
  if(B == Gosu::kbEscape){
	close();
  }
  if(principal_==1)
  {
    principal->buttonDown(B, input(), principal_, menu_, guardado_,puntuacion_total_);
  }

  else if(nivel_ != "0"){ //si stamos en un nivel 
    nivel->buttonDown(B, input(), animacion_, mira_, menu_, principal_,nivel_, t, guardado_,completo_,puntuacion_,puntuacion_total_);
  }
  
  else if(menu_ == 1){ //si estamos en el menu de niveles
    menu->buttonDown(B, input(), nivel_, principal_, menu_,creditos_, guardado_);
    if(nivel_ != "0"){
      t = new tablero(nivel_); //Creamos el tablero dependiendo del nivel elegido
      sonido_.cambiarnivel();
      menu_ = 0;	//Si hemos elegido un nivel. Ponemos el menu a 0 para que no se vuelva a mostrar
    }
  }

  else if(creditos_ == 1){
    creditos->buttonDown(B, menu_, creditos_);
  }
  else if(completo_ == 1){
    c->buttonDown(B,menu_,completo_);
  }
}	
