#include <Gosu/Gosu.hpp>
#include "tablero.h"
#include "principal.h"
#include "menu.h"
#include "nivel.h"
#include "sonido.h"
#include "Creditos.h"
#include "nube.h"

/**
 * @brief Clase ventana principal
 * 
 * @author Lourdes, Lucia, Ezequiel y Kaan.
 */

class Ventana: public Gosu::Window{ //hera publicamente de la clase Window de la libreria Gosu 

public:
  /**Constructor de Ventana*/
  Ventana(Sonido & sonido);
  /**Destructor de Ventana */ 
  ~Ventana(); 
  /**Función para la logica del juego */
  void update();
  /**Función para que aparezca el cursor en la ventana */
  bool needsCursor()const{ return true; }
  /**Función para dibujar los graficos */
  void draw();
  /**Función que se ejecuta cuando se pulsa una tecla*/
  void buttonDown(Gosu::Button B);
  
private:
  /** { @ Variables para indicar en que pantalla del juego nos entontramos */
  int menu_;
  string nivel_;
  int principal_;
  int mira_;
  int animacion_;
  int guardado_;
  int creditos_;
  int completo_;
  int puntuacion_;
  float puntuacion_total_;
  /** @ } */
  
  /**Atributos para para los distintos objetos de las otras clases*/
  tablero * t; 
  Principal *principal; //objeto de la clase principal
  Menu * menu;
  Nivel *nivel;
  Nube * nube;
  Completado * c;
  Sonido sonido_;
  Creditos * creditos;
  
  /**OBJETO IMAGE para el fondo */
  Gosu::Image * fondo;  //fondo
 
};

